//
//  MTKeyMap.h
//  MacTrek
//
//  Created by Aqua on 21/04/2006.
//  Copyright 2006 Luky Soft. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MTKeyMapEntry.h"

// the action invoked by the keypress
#define ACTION_UNKNOWN           0
#define ACTION_CLOAK             1
#define ACTION_DET_ENEMY         2
#define ACTION_DET_OWN           3
#define ACTION_FIRE_PLASMA       4
#define ACTION_FIRE_TORPEDO      5
#define ACTION_FIRE_PHASER       6
#define ACTION_SHIELDS           7
#define ACTION_TRACTOR           8
#define ACTION_PRESSOR           9
#define ACTION_WARP_0           10
#define ACTION_WARP_1           11
#define ACTION_WARP_2           12
#define ACTION_WARP_3           13
#define ACTION_WARP_4           14
#define ACTION_WARP_5           15
#define ACTION_WARP_6           16
#define ACTION_WARP_7           17
#define ACTION_WARP_8           18
#define ACTION_WARP_9           19
#define ACTION_WARP_10          20
#define ACTION_WARP_11          21
#define ACTION_WARP_12          22
#define ACTION_WARP_MAX         23
#define ACTION_WARP_HALF_MAX    24
#define ACTION_WARP_INCREASE    25
#define ACTION_WARP_DECREASE    26
#define ACTION_SET_COURSE       27
#define ACTION_LOCK             28
#define ACTION_PRACTICE_BOT     29
#define ACTION_TRANSWARP        30
#define ACTION_BOMB             31
#define ACTION_ORBIT            32
#define ACTION_BEAM_DOWN        33
#define ACTION_BEAM_UP          34
#define ACTION_DISTRESS_CALL    35
#define ACTION_ARMIES_CARRIED_REPORT 36
#define ACTION_MESSAGE          37
#define ACTION_DOCK_PERMISSION  38
#define ACTION_INFO             39
#define ACTION_REFIT            40
#define ACTION_REPAIR           41
#define ACTION_QUIT             42
#define ACTION_HELP             43
#define ACTION_DEBUG            44

#define ACTION_SCREENSHOT       45


@interface MTKeyMap : NSObject {
    NSMutableDictionary *keyMap;
    bool changedSinceLastWrite;
    NSString *pathToKeyMap;
}

//- (id) initWithDefaultFile;
//- (id) initWithFile:(NSString *) file;
- (void) writeToFile:(NSString *)file;
- (void) readDefaultKeyMap;
- (int) actionForKey:(char) key withModifierFlags:(unsigned int) flags;
- (NSString *) descriptionForAction:(int) action;
- (char) keyForAction:(int) action;
- (unsigned int) flagsForAction:(int) action;
- (void) setKey: (char) key forAction:(int) action;
- (void) setFlags: (unsigned int) flags ForAction:(int) action;
- (int) count;
- (NSArray *)allKeys;
- (void)writeToDefaultFileIfChanged;

@end
