//
//  ServerReaderTcp.m
//  MacTrek
//
//  Created by Aqua on 06/05/2006.
//  Copyright 2006 Luky Soft. All rights reserved.
//

#import "ServerReaderTcp.h"

@implementation ServerReaderTcp

ONSocketStream *stream;

- (id) init {
    self = [super init];
    if (self != nil) {
        stream = nil; // very bad if we get here
    }
    return self;
}

- (id)initWithUniverse:(Universe*)newUniverse communication:(Communication*)comm
                socket:(ONTCPSocket*) socket {

    self = [super initWithUniverse:newUniverse communication:comm];
    if (self != nil) {
        // connect has already been done and create a stream
        stream = [ONSocketStream streamWithSocket:socket];
        [stream retain];
    }
    return self;
}

- (NSData *) doRead {
    // read max one TCP frame per time
    NSData *result = [stream readDataWithMaxLength:1536];
    return result;
}

- (void) close {
    [stream release];
    stream = nil;
}

@end
