//
//  Entity.m
//  MacTrek
//
//  Created by Aqua on 27/04/2006.
//  Copyright 2006 Luky Soft. All rights reserved.
//

#import "Entity.h"


@implementation Entity

- (id) init {
    self = [super init];
    if (self != nil) {
        dir = 0;
        speed = 0;
        position.x = -1000;
        position.y = -1000;
        showInfo = NO;
        fuse = 0;
        step = 1;
        maxfuse = 100;
    }
    return self;
}

- (NSString*) labelKey {
    return labelKey;
}

- (NSImage*)  label {
    return label;
}

- (NSImage*)  labelForKey:(NSString *)key {
    if ([key isEqualToString:labelKey]) {
        return label;
    }
    else {
        return nil;
    }
}

- (bool) setLabel:(NSImage*)newLabel forKey:(NSString *)newKey {
    // check if we know this one
    if ([newKey isEqualToString:labelKey]) {
        return YES;
    } 
    [labelKey release];
    [label release];
    label = newLabel;
    labelKey = newKey;
    [label retain];
    [labelKey retain];
    return NO;
}

- (void) setNetrekFormatCourse:(char)newDir {
    // netrek uses a byte 0-255 to represent a course
    // we use a float, 0-360
    dir = newDir * 360 / 255;
    if (dir < 0) {
        dir += 360;
    } 
}

- (void) setRequestedCourse:(int)newDir {
    requestedDir = newDir;
}

- (void) setRequestedSpeed:(int)fast {
    requestedSpeed = fast;
}

- (void) setCourse:(int)newDir {
    dir = newDir;
}

- (void) setSpeed:(int)fast {
    speed = fast;
}

- (void) setPosition:(NSPoint)pos {
    position = pos;
}

- (void) setShowInfo:(bool)show {
    showInfo = show;
}

- (NSPoint) predictedPosition {  // extend later
    return position;
}

- (NSPoint) position {
    return position;
}

- (char) netrekFormatCourse {
    return (dir * 255 / 360);
}

- (int) requestedCourse {
    return requestedDir;
}

- (int) requestedSpeed {
    return requestedSpeed;
}

- (int) course {
    return dir;
}

- (int) predictedCourse { // extend later
    return dir;
}

- (float) dirInRad {
    // int dir = 0..360 deg
    // radians are 0..2xpi
    return (dir * pi) / 180;    
}

- (int) speed {
    return speed;
}

- (bool)showInfo {
    return showInfo;
}

- (int)  fuse {
    return fuse;
}

- (int)  maxfuse {
    return maxfuse;
}

-(void) setMaxFuse:(int)newLevel {
    maxfuse = newLevel;
}

-(void) setFuseStep:(int)newLevel {
    step = newLevel;
}

-(void) setFuse:(int)newLevel {
    fuse = newLevel;
}

- (void) increaseFuse {
    fuse += step;
}

- (void) decreaseFuse {
    fuse -= step;
}

- (void) resetFuse {
    fuse = 0;
}

@end
