//
//  NSCursor+CustomCursors.m
//  Cursors
//
//  Created by don on Wed Oct 31 2001.
//  Copyright (c) 2001 Don Yacktman. All rights reserved.
//

#import "NSCursor+CustomCursors.h"


@implementation NSCursor(CustomCursors)

+ (NSCursor *)pencilCursor
{
    static NSCursor *pencilCursor = nil;
    if (!pencilCursor) {
        NSImage *pencil = [NSImage imageNamed:@"Pencil"];
        NSPoint hotspot = NSMakePoint(0.0, 15.0); // lower left
        pencilCursor = [[NSCursor alloc] initWithImage:pencil hotSpot:hotspot];
    }
    return pencilCursor;
}

+ (NSCursor *)crossCursor
{
    static NSCursor *crossCursor = nil;
    if (!crossCursor) {
        NSImage *crosshair = [NSImage imageNamed:@"Cross"];
        // hot spot is at center of image
        NSSize crossSize = [crosshair size];
        NSPoint hotspot = NSMakePoint((crossSize.width / 2.0), (crossSize.height / 2.0));
        crossCursor = [[NSCursor alloc] initWithImage:crosshair hotSpot:hotspot];
    }
    return crossCursor;
}

@end
