//
//  PainterFactoryForTac.m
//  MacTrek
//
//  Created by Aqua on 23/07/2006.
//  Copyright 2006 Luky Soft. All rights reserved.
//

#import "PainterFactoryForTac.h"


@implementation PainterFactoryForTac

- (void)   drawPlayer:(Player*) player inRect:(NSRect) Rect {
    
    NSColor *col = [self colorForTeam:[player team]];
    if ([player flags] & PLAYER_CLOAK) {
        // find out aplha value PF_MIN_ALPHA_VALUE (0.1) means fully cloaked
        // 1.0 means fully uncloaked
        float alpha = 1.0;
        alpha -= (((1.0 - PF_MIN_ALPHA_VALUE) * [player cloakPhase]) / PLAYER_CLOAK_PHASES);
        col = [col colorWithAlphaComponent:alpha];
    }    
    [col set];
    
    // draw the ship in a sqrt(2)/2 size rect (inner circle)
    // sides should be 0.707 * rect.width thus reduced by 0,292893218813 / 2  
    // but i like the base a bit smaller
    [shapes drawTriangleNotchUpInRect:NSInsetRect(Rect, Rect.size.width*0.1000, Rect.size.height*0.1515)];
}


- (void) drawShipType:(int)type forTeamId:(int) teamId withCloakPhase:(int)cloakPhase inRect:(NSRect)Rect {
	Player *p;
	
	p = [[Player alloc] init];
	
	[p setTeam:[universe teamWithId:teamId]];
	[self drawPlayer:p inRect:Rect];
	
	[p release];
}

@end
