//
//  MapView.m
//  MacTrek
//
//  Created by Aqua on 02/06/2006.
//  Copyright 2006 Luky Soft. All rights reserved.
//

#import "MapView.h"


@implementation MapView

NSRect gameBounds;

- (void) awakeFromNib {
    [super awakeFromNib];
    
    // use larger steps to zoom
    step *= 2; // twice
    
    [self setScaleFullView];
    // should disable torps etc
    
    // find out what are the gameBounds
    gameBounds.origin.x = 0;
    gameBounds.origin.y = 0;
    gameBounds.size.width = UNIVERSE_PIXEL_SIZE;
    gameBounds.size.height = UNIVERSE_PIXEL_SIZE;

    centerPoint = NSMakePoint(UNIVERSE_PIXEL_SIZE/2, UNIVERSE_PIXEL_SIZE/2);
    
    // use the default painter here, we could use the same theme....
    // $$ are we sure?
    painter = [[PainterFactory alloc] init];
    
    // use simpler drawing (eg omit weapons)
    [painter setSimplifyDrawing:YES];
}

- (NSPoint) gamePointRepresentingCentreOfView {
    return centerPoint;
}

- (void) keyDown:(NSEvent *)theEvent {
    NSLog(@"MapView.keyDown entered");
    [super keyDown:theEvent];
}

// draw the view 
// without locking the read thread !!
- (void)drawRect:(NSRect)aRect {
    [painter drawRect:aRect ofViewBounds:[self bounds] whichRepresentsGameBounds:gameBounds withScale:scale];
}

- (void) mouseDown:(NSEvent *)theEvent {
    // where you click becomes the center
    centerPoint = [painter gamePointFromViewPoint:[self mousePos] 
                                             viewRect:[self bounds]
                                gamePosInCentreOfView:[self gamePointRepresentingCentreOfView] 
                                            withScale:scale]; 
    
    // set up the gamebounds based on my position
    gameBounds = [painter gameRectAround:[self gamePointRepresentingCentreOfView]
                                        forView:[self bounds]
                                      withScale:scale]; 
}

- (void) scrollWheel:(NSEvent *)theEvent {

    [super scrollWheel:theEvent];
    // set up the gamebounds based on my position AND SCALE
    gameBounds = [painter gameRectAround:[self gamePointRepresentingCentreOfView]
                                 forView:[self bounds]
                               withScale:scale]; 
}


- (void) otherMouseDown:(NSEvent *)theEvent {
    // no phaser
}

@end
